{-# OPTIONS_HADDOCK show-extensions #-}

-- |
-- Module      :  Phonetic.Languages.Array.Ukrainian.PropertiesFuncRepG2
-- Copyright   :  (c) OleksandrZhabenko 2020-2022
-- License     :  MIT
-- Stability   :  Experimental
-- Maintainer  :  olexandr543@yahoo.com
--
-- Generalization of the functionality of the DobutokO.Poetry.Norms
-- and DobutokO.Poetry.Norms.Extended modules
-- from the @dobutokO-poetry@ package. Instead of vectors, uses arrays.

{-# LANGUAGE CPP, BangPatterns #-}

module Phonetic.Languages.Array.Ukrainian.PropertiesFuncRepG2 (
  -- * Basic functions
  -- ** Functions with 'Int16'
  procDiverse2I
  -- ** Functions with 'Double'
  -- *** More general
  , procB2FG
  , procB2InvFG
  -- *** Usual ones
  , procDiverse2F
  , procBothF
  , procBothFF
  , procBothInvF
  , procBothInvFF
  -- *** Working with generated by r-glpk-phonetic-languages-ukrainian-durations syllable durations
  , procBoth2F
  , procBoth2FF
  , procBoth2InvF
  , procBoth2InvFF
  -- *** NEW Working with generated by r-glpk-phonetic-languages-ukrainian-durations syllable durations
  , procBoth3F
  , procBoth3FF
  , procBoth3InvF
  , procBoth3InvFF
  , procBoth4F
  , procBoth4FF
  , procBoth4InvF
  , procBoth4InvFF
  -- ** Working with rhythmicity
  , procRhythmicity23F
  -- *** Working with rhythmicity that can be defined by the user (using 'rhythmicityH')
  , procRhythmicity23FH
  -- * Extended functions
  -- ** Functions with 'Int16'
  , procDiverse2ITup
  -- ** Functions with 'Double'
  -- *** More general
  , procB2FGTup
  , procB2InvFGTup
  -- *** Usual ones
  , procDiverse2FTup
  , procBothFTup
  , procBothFFTup
  , procBothInvFTup
  , procBothInvFFTup
  -- *** Working with generated by r-glpk-phonetic-languages-ukrainian-durations syllable durations
  , procBoth2FTup
  , procBoth2FFTup
  , procBoth2InvFTup
  , procBoth2InvFFTup
  -- *** NEW Working with generated by r-glpk-phonetic-languages-ukrainian-durations syllable durations
  , procBoth3FTup
  , procBoth3FFTup
  , procBoth3InvFTup
  , procBoth3InvFFTup
  , procBoth4FTup
  , procBoth4FFTup
  , procBoth4InvFTup
  , procBoth4InvFFTup
  -- ** Working with rhythmicity
  , procRhythmicity23FTup
  -- *** Working with rhythmicity that can be defined by the user (using 'rhythmicityH')
  , procRhythmicity23FHTup
) where

import Phonetic.Languages.Array.Ukrainian.PropertiesFuncRepG2Common
import Phonetic.Languages.Array.Ukrainian.PropertiesFuncRepG2Diverse
import Phonetic.Languages.Array.Ukrainian.PropertiesFuncRepG2Rhythmicity
import Phonetic.Languages.Array.Ukrainian.PropertiesFuncRepG21
import Phonetic.Languages.Array.Ukrainian.PropertiesFuncRepG22
import Phonetic.Languages.Array.Ukrainian.PropertiesFuncRepG23
import Phonetic.Languages.Array.Ukrainian.PropertiesFuncRepG24
